/*
 * Scala JavaScript support library 1.1
 * 
 * Copyright 2012, Scala Incorporated
 * 
 */

Scala = {};
// Global metadata name/value arrays 
var _ScalaMetadataNames=null;
var _ScalaMetadataValues=null;

Scala.done=function() {
	try {
		if (window.ScalaPlayer=="TRUE") {
			// Scala Player's embedded browser
			window.ScalaDone();
		}
		else
		if(parent!=null) {
			if(parent.window!=null) {
				if(window!=null) {
					if(window.frameElement!=null) {
						parent.window.postMessage(window.frameElement.name, '*');
						console.debug("Scala.done()");
					}
				}
			}
		}
	} catch(e) {
		console.error("Scala.done() not supported");
	}

}

Scala.getMetadataValue=function(name) {
	var value=null;
	try {
		if (window.ScalaPlayer=="TRUE") {
			// Scala Player's embedded browser
			value=window.ScalaGetMetadataValue(name);
			if (value=="&lt;undefined&gt;") {
				value=null;
			}
		}
		else {
			if(_ScalaMetadataNames==null || _ScalaMetadataValues==null) {
				// Decode metadata on first time use
				var names=new Array();
				var values=new Array();
				var formdata=location.href.split('?')[1];
				if(formdata!=null&&formdata.length>0) {
					var data=formdata.split('&');
					for(var i=0;i<data.length;i++) {
						var types=decodeURIComponent(data[i]);
						if(types.indexOf('metadata=')==0) {
							var metadata=types.substring("metadata=".length).split('&');
							for(var j=0;j<metadata.length;j++) {
								var entry=metadata[j];
								var t=entry.indexOf('=');
								names[names.length]=decodeURIComponent(entry.substring(0,t));
								values[values.length]=decodeURIComponent(entry.substring(t+1));
							}
						}
					}
				}
				_ScalaMetadataNames=names;
				_ScalaMetadataValues=values;
			}

			var i=_ScalaMetadataNames.indexOf(name);
			if(i != -1) {
				value=_ScalaMetadataValues[i];
			}
		}
	} catch(e) {
		console.error("Scala Player Metadata not available");
	}
	return value;
}
